export type ITypeContentItem = {
  name: IVocals
  direction: 'vertical' | 'transverse'
  width?: string
  height?: string
  paddingLeft?: string
  paddingRight?: string
}

type ITypeContent = {
  [key: string]: ITypeContentItem
}

export type IVocals =
  | 'flute'
  | 'clarinet'
  | 'saxophone'
  | 'trumpet'
  | 'horn'
  | 'trombone'
  | 'up-bass-horn'
  | 'small-drum'
  | 'tuba'
  | 'piccolo'
  | 'ukulele'
  | 'melodica'
  | 'piano'
  | 'mouthorgan'
  | 'hulusi-flute'
  | 'pan-flute'
  | 'ocarina'
  | 'melodica'

export const typeById: ITypeContent = {
  2: {
    name: 'flute',
    direction: 'transverse',
  }, // 长笛
  4: {
    name: 'clarinet',
    direction: 'vertical',
    width: '1rem',
    paddingLeft: '0rem',
  }, // 单簧管
  5: {
    name: 'saxophone',
    direction: 'vertical',
    width: '2rem',
  }, // 萨克斯
  6: {
    name: 'saxophone',
    direction: 'vertical',
    width: '2rem',
  }, // 中音萨克斯
  12: {
    name: 'trumpet',
    direction: 'transverse',
    height: '80px',
  }, // 小号
  13: {
    name: 'horn',
    direction: 'vertical',
    width: '3.5rem',
  }, // 圆号
  14: {
    name: 'trombone',
    direction: 'transverse',
    height: '80px',
  }, // 长号
  15: {
    name: 'up-bass-horn',
    direction: 'vertical',
    width: '3rem',
  }, // 上低音号
  17: {
    name: 'tuba',
    direction: 'vertical',
    width: '3rem',
  }, // 大号
  // 23: {
  //   name: 'small-drum',
  //   direction: 'vertical'
  // }, // 打击乐
  120: {
    name: 'piccolo',
    direction: 'vertical',
    width: '1rem',
  }, // 短笛
  136: {
    name: 'hulusi-flute',
    direction: 'vertical',
    width: '1.2rem',
  }, // 葫芦丝
  135: {
    name: 'pan-flute',
    direction: 'vertical',
    width: '2.5rem',
  }, // 排箫
  134: {
    name: 'ocarina',
    direction: 'vertical',
    width: '2rem',
  }, // 陶笛
  137: {
    name: 'melodica',
    direction: 'transverse',
  }, // 口风琴
  130: {
    name: 'ukulele',
    direction: 'vertical',
    width: '2rem',
  }, // 尤克里里
  140: {
    name: 'mouthorgan',
    direction: 'transverse',
    height: '80px',
  },
  150: {
    name: 'piano',
    direction: 'transverse',
    height: '80px',
  },
}
