import { defineComponent, onMounted } from "vue";
import styles from "./index.module.less";
import { Vue3Lottie } from "vue3-lottie";
import data from "./data.json";
import icon_tip from './icon_tip.png'

export default defineComponent({
	name: "PhoneTip",
    props: {
        show: {
            type: Boolean,
            default: false
        }
    },
	setup(props) {
		return () => (
			<div id="PhoneTipContent" class={[styles.box, props.show ? styles.animate__scale : '']}>
                <img class={styles.iconTip} src={icon_tip} />
				<Vue3Lottie animationData={data} speed={2}></Vue3Lottie>
			</div>
		);
	},
});
