export type BackgroundRecord = {
  audioFileUrl?: string
  track?: string
  metronomeUrl?: string
}

export type OrderStatus = 'WAIT_PAY' | 'PAYING' | 'PAID'

export type MusicSheelDetail = {
  id?: number
  // 声部对应code
  code?: string
  // 是否允许播放
  play?: number
  // 音频文件地址
  audioFileUrl?: string
  // 额外配置(前端自行定义)
  extConfigJson?: string
  // xml文件地址
  xmlFileUrl?: string
  // 伴奏mp3地址
  url?: string
  // 伴奏mp3带节拍器
  metronomeUrl?: string
  // 伴奏mp3地址
  background?: BackgroundRecord[]
  // 作曲人
  composer?: string
  // 收费方式
  chargeType?: string
  // 收费方式
  paymentType?: string
  // 收费价格
  musicPrice?: number
  // 曲目名称
  musicSheetName?: string
  // 音频文件类型
  audioType?: 'MIDI' | 'MP3'
  // Mp3文件是否包含节拍器
  mp3Type?: 'MP3_METRONOME' | 'MP3'
  // midiUrl
  midiUrl?: string
  // 曲目声部ID
  musicSubject?: string
  // 曲目声部名称
  subjectNames?: string
  // 订单状态
  orderStatus?: OrderStatus
  /** 是否支持简谱 */
  notation?: number
  /** 默认评测频率 */
  aiDefaultFrequency?: number
  /** 已经生成的图片 */
  musicImg?: string
  /** 缓存的json 地址 */
  musicJSON?: string
  /** 缓存的svg 地址 */
  musicSvg?: string
  /** 缓存的svg简谱 地址 */
  musicJianSvg?: string
  /** 缓存的svg固定调 地址 */
  musicFirstSvg?: string
  /**后台曲谱设置的速度 */
  playSpeed?: number
  /** 曲谱类型 */
  musicSheetType?: string
}

export type ShaeetStatusType = 'loading' | 'error' | 'success'
