import { Button } from "vant";
import { defineComponent } from "vue";
import iconMicrophone from "./icons/microphone.svg";
import styles from "./index.module.less";
import classNames from "classnames";

export default defineComponent({
  name: "ColexiuMicrophone",
  setup(props, { expose }) {
    return () => (
      <div>
        <img class={styles.image} src={iconMicrophone} />
        <div class={styles.wrap}>
          <div class={styles.des}>
            <div class={styles.title}>开启权限</div>
            <div class={styles.sub}>请开启麦克风访问权限</div>
          </div>
          <div class={styles.btnWrap}>
            <Button class={classNames(styles.btn, styles.cancelBtn)}></Button>
            <Button class={classNames(styles.btn, styles.confirmBtn)}></Button>
          </div>
        </div>
      </div>
    );
  },
});
