import { defineComponent } from 'vue'
import { Tab, Tabs } from 'vant'
import Seet from './sett'
import styles from './index.module.less'
import Practise from './practise'
import Evaluat from './evaluat'

export default defineComponent({
  name: 'ColexiuSetting',
  props: {
    active: {
      type: String,
      default: '1'
    }
  },
  setup(props) {
    return () => (
      <div class={styles.setting}>
        <Tabs active={props.active}>
          <Tab title="全局设置" name="1">
            <Seet />
          </Tab>
          <Tab title="练习设置" name="2">
            <Practise />
          </Tab>
          <Tab title="评测设置" name="3">
            <Evaluat />
          </Tab>
        </Tabs>
      </div>
    )
  },
})
